diff -uNrd ircd-ratbox-1.5-2/modules/m_testmask.c ircd-rb-FDF6.3a/modules/m_testmask.c
--- ircd-ratbox-1.5-2/modules/m_testmask.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_testmask.c	Mon May 31 00:02:25 2004
@@ -29,7 +29,7 @@
  *  IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  *  POSSIBILITY OF SUCH DAMAGE.
  *
- *  $Id: m_testmask.c,v 1.1.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_testmask.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  *
  */
 
@@ -72,7 +72,7 @@
 	mod_del_cmd(&testmask_msgtab);
 }
 
-const char *_version = "$Revision: 1.1.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 static void
diff -uNrd ircd-ratbox-1.5-2/modules/m_time.c ircd-rb-FDF6.3a/modules/m_time.c
--- ircd-ratbox-1.5-2/modules/m_time.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_time.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_time.c,v 1.39.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_time.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -59,7 +59,7 @@
 	mod_del_cmd(&time_msgtab);
 }
 
-const char *_version = "$Revision: 1.39.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_time
diff -uNrd ircd-ratbox-1.5-2/modules/m_topic.c ircd-rb-FDF6.3a/modules/m_topic.c
--- ircd-ratbox-1.5-2/modules/m_topic.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_topic.c	Tue Jun  1 20:20:14 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_topic.c,v 1.77.2.4 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_topic.c,v 1.5 2004/06/02 00:20:14 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -64,7 +64,7 @@
 	mod_del_cmd(&topic_msgtab);
 }
 
-const char *_version = "$Revision: 1.77.2.4 $";
+const char *_version = "$Revision: 1.5 $";
 #endif
 /*
  * m_topic
@@ -78,6 +78,7 @@
 	struct Channel *chptr = NULL;
 	struct membership *msptr;
 	char *p = NULL;
+	int sline;
 
 	if(EmptyString(parv[1]))
 	{
@@ -106,14 +107,15 @@
 		/* setting topic */
 		if(parc > 2)
 		{
+			sline = IsSLine(source_p);
 			msptr = find_channel_membership(chptr, source_p);
-			if(msptr == NULL)
+			if((msptr == NULL) && !sline)
 			{
 				sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
 					   parv[1]);
 				return;
 			}
-			if((chptr->mode.mode & MODE_TOPICLIMIT) == 0 || is_chanop(msptr))
+			if((chptr->mode.mode & MODE_TOPICLIMIT) == 0 || is_chanop(msptr) || sline)
 			{
 				char topic_info[USERHOST_REPLYLEN];
 				ircsprintf(topic_info, "%s!%s@%s",
@@ -139,7 +141,12 @@
 		}
 		else		/* only asking  for topic  */
 		{
-			if(!IsMember(source_p, chptr) && SecretChannel(chptr))
+			int oper_can_see = 0;
+
+			if (ConfigChannel.opers_see_hidden && IsOper(source_p))
+				oper_can_see=1;
+
+			if(!IsMember(source_p, chptr) && SecretChannel(chptr) && !oper_can_see)
 			{
 				sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, parv[0],
 					   parv[1]);
diff -uNrd ircd-ratbox-1.5-2/modules/m_trace.c ircd-rb-FDF6.3a/modules/m_trace.c
--- ircd-ratbox-1.5-2/modules/m_trace.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_trace.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_trace.c,v 1.78.2.7 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_trace.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -63,7 +63,7 @@
 {
 	mod_del_cmd(&trace_msgtab);
 }
-const char *_version = "$Revision: 1.78.2.7 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 static int report_this_status(struct Client *source_p, struct Client *target_p, int dow,
diff -uNrd ircd-ratbox-1.5-2/modules/m_unkline.c ircd-rb-FDF6.3a/modules/m_unkline.c
--- ircd-ratbox-1.5-2/modules/m_unkline.c	Thu Jun 10 11:52:22 2004
+++ ircd-rb-FDF6.3a/modules/m_unkline.c	Thu Jun 17 22:04:22 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_unkline.c,v 1.90.2.10 2004/06/10 15:52:22 androsyn Exp $
+ *  $Id: m_unkline.c,v 1.10 2004/06/18 02:04:22 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -78,7 +78,7 @@
 	mod_del_cmd(&msgtabs[1]);
 	mod_del_cmd(&msgtabs[2]);
 }
-const char *_version = "$Revision: 1.90.2.10 $";
+const char *_version = "$Revision: 1.10 $";
 #endif
 
 static void handle_remote_unkline(struct Client *, const char *, const char *);
@@ -687,14 +687,16 @@
 {
 	const char *user;
 	char *host;
+	int sline;
 
-	if(!ConfigFileEntry.glines)
-	{
-		sendto_one(source_p, ":%s NOTICE %s :UNGLINE disabled", me.name, parv[0]);
-		return;
-	}
+	sline = IsSLine(source_p);
 
-	if(!IsOperUnkline(source_p) || !IsOperGline(source_p))
+	if (sline) /* Propogate service's UNGLINEs -JailBird */
+		sendto_server(client_p, NULL, CAP_GLN, NOCAPS,
+			      ":%s UNGLINE :%s",
+			      source_p->name, parv[1]);
+
+	if((!IsOperUnkline(source_p) || !IsOperGline(source_p)) && !sline)
 	{
 		sendto_one(source_p, ":%s NOTICE %s :You need unkline = yes;", me.name, parv[0]);
 		return;
diff -uNrd ircd-ratbox-1.5-2/modules/m_user.c ircd-rb-FDF6.3a/modules/m_user.c
--- ircd-ratbox-1.5-2/modules/m_user.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_user.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_user.c,v 1.36.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_user.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
 	mod_del_cmd(&user_msgtab);
 }
 
-const char *_version = "$Revision: 1.36.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
 ** mr_user
diff -uNrd ircd-ratbox-1.5-2/modules/m_userhost.c ircd-rb-FDF6.3a/modules/m_userhost.c
--- ircd-ratbox-1.5-2/modules/m_userhost.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_userhost.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_userhost.c,v 1.50.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_userhost.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
 	mod_del_cmd(&userhost_msgtab);
 }
 
-const char *_version = "$Revision: 1.50.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_userhost added by Darren Reed 13/8/91 to aid clients and reduce
diff -uNrd ircd-ratbox-1.5-2/modules/m_users.c ircd-rb-FDF6.3a/modules/m_users.c
--- ircd-ratbox-1.5-2/modules/m_users.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_users.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_users.c,v 1.36.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_users.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -57,7 +57,7 @@
 	mod_del_cmd(&users_msgtab);
 }
 
-const char *_version = "$Revision: 1.36.2.3 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /*
diff -uNrd ircd-ratbox-1.5-2/modules/m_version.c ircd-rb-FDF6.3a/modules/m_version.c
--- ircd-ratbox-1.5-2/modules/m_version.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_version.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_version.c,v 1.55.2.3 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_version.c,v 1.4 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include <stdinc.h>
@@ -61,7 +61,7 @@
 	mod_del_cmd(&version_msgtab);
 }
 
-const char *_version = "$Revision: 1.55.2.3 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
  * m_version - VERSION command handler
@@ -158,8 +158,7 @@
 	if(ConfigChannel.use_except)
 		*p++ = 'e';
 
-	if(ConfigFileEntry.glines)
-		*p++ = 'g';
+	*p++ = 'g';
 	*p++ = 'G';
 
 	/* might wanna hide this :P */
@@ -176,10 +175,6 @@
 
 	*p++ = 'M';
 	*p++ = 'p';
-
-#ifdef IGNORE_BOGUS_TS
-	*p++ = 'T';
-#endif
 
 #ifdef USE_SYSLOG
 	*p++ = 'Y';
diff -uNrd ircd-ratbox-1.5-2/modules/m_wallops.c ircd-rb-FDF6.3a/modules/m_wallops.c
--- ircd-ratbox-1.5-2/modules/m_wallops.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_wallops.c	Mon May 31 00:02:25 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_wallops.c,v 1.45.2.6 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_wallops.c,v 1.3 2004/05/31 04:02:25 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -58,7 +58,7 @@
 	mod_del_cmd(&wallops_msgtab);
 }
 
-const char *_version = "$Revision: 1.45.2.6 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * mo_wallops (write to *all* opers currently online)
diff -uNrd ircd-ratbox-1.5-2/modules/m_who.c ircd-rb-FDF6.3a/modules/m_who.c
--- ircd-ratbox-1.5-2/modules/m_who.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_who.c	Tue Jun  1 20:20:14 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_who.c,v 1.96.2.8 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_who.c,v 1.8 2004/06/02 00:20:14 jailbird Exp $
  */
 #include "stdinc.h"
 #include "tools.h"
@@ -63,12 +63,12 @@
 {
 	mod_del_cmd(&who_msgtab);
 }
-const char *_version = "$Revision: 1.96.2.8 $";
+const char *_version = "$Revision: 1.8 $";
 #endif
 static void do_who_on_channel(struct Client *source_p, struct Channel *chptr,
 			      int server_oper, int member);
 
-static void who_global(struct Client *source_p, char *mask, int server_oper, int);
+static void who_global(struct Client *source_p, char *mask, int server_oper, int whois_cheat, int oper_can_see);
 
 static void do_who(struct Client *source_p, struct Client *target_p, const char *chname, const char *op_flags);
 
@@ -91,6 +91,7 @@
 	int server_oper = parc > 2 ? (*parv[2] == 'o') : 0;	/* Show OPERS only */
 	int member;
 	int whois_cheat = 0;
+	int oper_can_see = 0;
 
 	/* See if mask is there, collapse it or return if not there */
 	collapse(mask);
@@ -101,6 +102,9 @@
 		return;
 	}
 
+	if (ConfigChannel.opers_see_hidden && IsOper(source_p))
+		oper_can_see=1;
+
 	/* '/who *' */
 	if((*(mask + 1) == (char) 0) && (*mask == '*'))
 	{
@@ -142,7 +146,7 @@
 		{
 			if(whois_cheat)
 				log_operspy(source_p, "WHO", chptr->chname);
-			if(IsMember(source_p, chptr) || whois_cheat)
+			if(IsMember(source_p, chptr) || whois_cheat || oper_can_see)
 				do_who_on_channel(source_p, chptr, server_oper, YES);
 			else if(!SecretChannel(chptr))
 				do_who_on_channel(source_p, chptr, server_oper, NO);
@@ -158,7 +162,7 @@
 	{
 		int isinvis = 0;
 
-		isinvis = IsInvisible(target_p);
+		isinvis = IsInvisible(target_p) && !oper_can_see;
 		DLINK_FOREACH(lp, target_p->user->channel.head)
 		{
 			msptr = lp->data;
@@ -203,9 +207,9 @@
 
 	/* '/who 0' */
 	if((*(mask + 1) == '\0') && (*mask == '0'))
-		who_global(source_p, NULL, server_oper, 0);
+		who_global(source_p, NULL, server_oper, 0, oper_can_see);
 	else
-		who_global(source_p, mask, server_oper, whois_cheat);
+		who_global(source_p, mask, server_oper, whois_cheat, oper_can_see);
 
 	/* Wasn't a nick, wasn't a channel, wasn't a '*' so ... */
 	sendto_one(source_p, form_str(RPL_ENDOFWHO), me.name, parv[0], mask);
@@ -275,14 +279,14 @@
  *		  this is slightly expensive on EFnet ...
  */
 static void
-who_global(struct Client *source_p, char *mask, int server_oper, int whois_cheat)
+who_global(struct Client *source_p, char *mask, int server_oper, int whois_cheat, int oper_can_see)
 {
 	struct Client *target_p;
 	struct membership *msptr;
 	dlink_node *lp, *ptr;
 	int maxmatches = 500;
 
-	if(!whois_cheat)
+	if(!whois_cheat && !oper_can_see)
 	{
 		/* first, list all matching INvisible clients on common channels */
 		DLINK_FOREACH(lp, source_p->user->channel.head)
@@ -291,7 +295,7 @@
 			who_common_channel(source_p, msptr->chptr, mask, server_oper, &maxmatches);
 		}
 	}
-	else
+	if (whois_cheat)
 		log_operspy(source_p, "WHO", mask);
 
 	/* second, list all matching visible clients */
@@ -301,7 +305,7 @@
 		if(!IsPerson(target_p))
 			continue;
 
-		if(IsInvisible(target_p) && !whois_cheat)
+		if(IsInvisible(target_p) && !whois_cheat && !oper_can_see)
 		{
 			ClearMark(target_p);
 			continue;
diff -uNrd ircd-ratbox-1.5-2/modules/m_whois.c ircd-rb-FDF6.3a/modules/m_whois.c
--- ircd-ratbox-1.5-2/modules/m_whois.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_whois.c	Mon May 31 00:02:26 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_whois.c,v 1.120.2.8 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_whois.c,v 1.3 2004/05/31 04:02:26 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -72,7 +72,7 @@
 	mod_del_cmd(&whois_msgtab);
 }
 
-const char *_version = "$Revision: 1.120.2.8 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
 ** m_whois
diff -uNrd ircd-ratbox-1.5-2/modules/m_whowas.c ircd-rb-FDF6.3a/modules/m_whowas.c
--- ircd-ratbox-1.5-2/modules/m_whowas.c	Thu May 20 08:06:37 2004
+++ ircd-rb-FDF6.3a/modules/m_whowas.c	Mon May 31 00:02:26 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_whowas.c,v 1.41.2.4 2004/05/20 12:06:37 leeh Exp $
+ *  $Id: m_whowas.c,v 1.3 2004/05/31 04:02:26 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -63,7 +63,7 @@
 {
 	mod_del_cmd(&whowas_msgtab);
 }
-const char *_version = "$Revision: 1.41.2.4 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 static int whowas_do(struct Client *client_p, struct Client *source_p, int parc, char *parv[]);
 
diff -uNrd ircd-ratbox-1.5-2/modules/m_xline.c ircd-rb-FDF6.3a/modules/m_xline.c
--- ircd-ratbox-1.5-2/modules/m_xline.c	Thu May 20 16:35:16 2004
+++ ircd-rb-FDF6.3a/modules/m_xline.c	Mon May 31 00:02:26 2004
@@ -26,7 +26,7 @@
  * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  * POSSIBILITY OF SUCH DAMAGE.
  *
- * $Id: m_xline.c,v 1.29.2.16 2004/05/20 20:35:16 leeh Exp $
+ * $Id: m_xline.c,v 1.3 2004/05/31 04:02:26 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -99,7 +99,7 @@
 	mod_del_cmd(&unxline_msgtab);
 }
 
-const char *_version = "$Revision: 1.29.2.16 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 
 /* m_xline()
diff -uNrd ircd-ratbox-1.5-2/servlink/README ircd-rb-FDF6.3a/servlink/README
--- ircd-ratbox-1.5-2/servlink/README	Sun May 27 15:57:22 2001
+++ ircd-rb-FDF6.3a/servlink/README	Mon Jan 19 22:26:03 2004
@@ -1,5 +1,5 @@
 Servlink protocol documentation.
-$Id: README,v 1.4 2001/05/27 19:57:22 davidt Exp $
+$Id: README,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
 --------------
 
 After negotiating an incoming/outgoing server connection, the ircd will
diff -uNrd ircd-ratbox-1.5-2/servlink/TODO ircd-rb-FDF6.3a/servlink/TODO
--- ircd-ratbox-1.5-2/servlink/TODO	Sun May 27 15:57:23 2001
+++ ircd-rb-FDF6.3a/servlink/TODO	Mon Jan 19 22:26:03 2004
@@ -1,5 +1,5 @@
 Servlink todo list
-$Id: TODO,v 1.5 2001/05/27 19:57:23 davidt Exp $
+$Id: TODO,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
 ------------------
 
 Fix any bugs that come up
diff -uNrd ircd-ratbox-1.5-2/servlink/control.c ircd-rb-FDF6.3a/servlink/control.c
--- ircd-ratbox-1.5-2/servlink/control.c	Thu Jun 26 10:02:52 2003
+++ ircd-rb-FDF6.3a/servlink/control.c	Mon Jan 19 22:26:03 2004
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: control.c,v 1.9.2.1 2003/06/26 14:02:52 androsyn Exp $
+ *   $Id: control.c,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 #include "setup.h"
diff -uNrd ircd-ratbox-1.5-2/servlink/control.h ircd-rb-FDF6.3a/servlink/control.h
--- ircd-ratbox-1.5-2/servlink/control.h	Thu Jun 26 10:02:52 2003
+++ ircd-rb-FDF6.3a/servlink/control.h	Mon Jan 19 22:26:03 2004
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: control.h,v 1.5.6.1 2003/06/26 14:02:52 androsyn Exp $
+ *   $Id: control.h,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 #ifndef INCLUDED_servlink_control_h
diff -uNrd ircd-ratbox-1.5-2/servlink/io.c ircd-rb-FDF6.3a/servlink/io.c
--- ircd-ratbox-1.5-2/servlink/io.c	Thu Jun 17 14:01:43 2004
+++ ircd-rb-FDF6.3a/servlink/io.c	Thu Jun 17 22:23:53 2004
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: io.c,v 1.33.2.2 2004/06/17 18:01:43 androsyn Exp $
+ *   $Id: io.c,v 1.2 2004/06/18 02:23:53 jailbird Exp $
  */
 
 #include "setup.h"
@@ -30,6 +30,7 @@
 #include <stdarg.h>
 #include <stdio.h>
 #include <unistd.h>
+#include <inttypes.h>
 
 #ifdef HAVE_LIBCRYPTO
 #include <openssl/evp.h>
@@ -239,7 +240,7 @@
 #ifdef HAVE_LIBZ
 	int i = 0;
 	int ret;
-	u_int32_t len;
+	uint32_t len;
 	if(!in_state.active || !out_state.active)
 		send_error("Error processing CMD_ZIPSTATS - link is not active!");
 	if(!in_state.zip || !out_state.zip)
@@ -249,25 +250,25 @@
 	ctrl_buf[i++] = 0;
 	ctrl_buf[i++] = 16;
 
-	len = (u_int32_t) in_state.zip_state.z_stream.total_out;
+	len = (uint32_t) in_state.zip_state.z_stream.total_out;
 	ctrl_buf[i++] = ((len >> 24) & 0xFF);
 	ctrl_buf[i++] = ((len >> 16) & 0xFF);
 	ctrl_buf[i++] = ((len >> 8) & 0xFF);
 	ctrl_buf[i++] = ((len) & 0xFF);
 
-	len = (u_int32_t) in_state.zip_state.z_stream.total_in;
+	len = (uint32_t) in_state.zip_state.z_stream.total_in;
 	ctrl_buf[i++] = ((len >> 24) & 0xFF);
 	ctrl_buf[i++] = ((len >> 16) & 0xFF);
 	ctrl_buf[i++] = ((len >> 8) & 0xFF);
 	ctrl_buf[i++] = ((len) & 0xFF);
 
-	len = (u_int32_t) out_state.zip_state.z_stream.total_in;
+	len = (uint32_t) out_state.zip_state.z_stream.total_in;
 	ctrl_buf[i++] = ((len >> 24) & 0xFF);
 	ctrl_buf[i++] = ((len >> 16) & 0xFF);
 	ctrl_buf[i++] = ((len >> 8) & 0xFF);
 	ctrl_buf[i++] = ((len) & 0xFF);
 
-	len = (u_int32_t) out_state.zip_state.z_stream.total_out;
+	len = (uint32_t) out_state.zip_state.z_stream.total_out;
 	ctrl_buf[i++] = ((len >> 24) & 0xFF);
 	ctrl_buf[i++] = ((len >> 16) & 0xFF);
 	ctrl_buf[i++] = ((len >> 8) & 0xFF);
diff -uNrd ircd-ratbox-1.5-2/servlink/io.h ircd-rb-FDF6.3a/servlink/io.h
--- ircd-ratbox-1.5-2/servlink/io.h	Thu Jun 26 10:02:52 2003
+++ ircd-rb-FDF6.3a/servlink/io.h	Mon Jan 19 22:26:03 2004
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: io.h,v 1.10.6.1 2003/06/26 14:02:52 androsyn Exp $
+ *   $Id: io.h,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 #ifndef INCLUDED_servlink_io_h
diff -uNrd ircd-ratbox-1.5-2/servlink/servlink.c ircd-rb-FDF6.3a/servlink/servlink.c
--- ircd-ratbox-1.5-2/servlink/servlink.c	Tue Mar 23 11:37:29 2004
+++ ircd-rb-FDF6.3a/servlink/servlink.c	Thu Apr  1 15:46:05 2004
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: servlink.c,v 1.28.2.6 2004/03/23 16:37:29 androsyn Exp $
+ *   $Id: servlink.c,v 1.1.1.2 2004/04/01 20:46:05 jailbird Exp $
  */
 
 #include "setup.h"
diff -uNrd ircd-ratbox-1.5-2/servlink/servlink.h ircd-rb-FDF6.3a/servlink/servlink.h
--- ircd-ratbox-1.5-2/servlink/servlink.h	Thu Jun 26 10:02:52 2003
+++ ircd-rb-FDF6.3a/servlink/servlink.h	Mon Jan 19 22:26:03 2004
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: servlink.h,v 1.23.2.1 2003/06/26 14:02:52 androsyn Exp $
+ *   $Id: servlink.h,v 1.1.1.1 2004/01/20 03:26:03 jailbird Exp $
  */
 
 #ifndef INCLUDED_servlink_servlink_h
diff -uNrd ircd-ratbox-1.5-2/src/.cvsignore ircd-rb-FDF6.3a/src/.cvsignore
--- ircd-ratbox-1.5-2/src/.cvsignore	Tue Jul  3 00:53:13 2001
+++ ircd-rb-FDF6.3a/src/.cvsignore	Mon Feb  9 17:22:57 2004
@@ -1,6 +1,6 @@
 Makefile
-y.tab.*
-lex.yy.c
 ircd
+lex.yy.c
 version.c.last
-version.c
+y.tab.c
+y.tab.h
diff -uNrd ircd-ratbox-1.5-2/src/adns.c ircd-rb-FDF6.3a/src/adns.c
--- ircd-ratbox-1.5-2/src/adns.c	Mon Mar 15 13:19:54 2004
+++ ircd-rb-FDF6.3a/src/adns.c	Thu Apr  1 16:20:50 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: adns.c,v 7.60.2.5 2004/03/15 18:19:54 leeh Exp $
+ *  $Id: adns.c,v 1.3 2004/04/01 21:20:50 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -101,6 +101,10 @@
 			assert(query->callback != NULL);
 			if(query->callback != NULL)
 			{
+				if(answer != NULL && answer->status == adns_s_systemfail)
+				{
+					failure = 1;
+				}
 				/* Awww we failed, what a shame */
 				query->query = NULL;
 				query->callback(query->ptr, NULL);
diff -uNrd ircd-ratbox-1.5-2/src/balloc.c ircd-rb-FDF6.3a/src/balloc.c
--- ircd-ratbox-1.5-2/src/balloc.c	Mon Mar 15 13:19:54 2004
+++ ircd-rb-FDF6.3a/src/balloc.c	Thu Jun 17 14:57:30 2004
@@ -26,7 +26,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: balloc.c,v 7.63.2.4 2004/03/15 18:19:54 leeh Exp $
+ *  $Id: balloc.c,v 1.5 2004/06/17 18:57:30 jailbird Exp $
  */
 
 /* 
@@ -260,7 +260,7 @@
 	s_assert(elemsize > 0 && elemsperblock > 0);
 
 	/* Catch idiotic requests up front */
-	if((elemsize <= 0) || (elemsperblock <= 0))
+	if((elemsize == 0) || (elemsperblock <= 0))
 	{
 		blockheap_fail("Attempting to BlockHeapCreate idiotic sizes");
 	}
diff -uNrd ircd-ratbox-1.5-2/src/channel.c ircd-rb-FDF6.3a/src/channel.c
--- ircd-ratbox-1.5-2/src/channel.c	Mon Apr 26 13:47:43 2004
+++ ircd-rb-FDF6.3a/src/channel.c	Thu Jun 17 14:57:30 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel.c,v 7.381.2.11 2004/04/26 17:47:43 leeh Exp $
+ *  $Id: channel.c,v 1.10 2004/06/17 18:57:30 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -171,7 +171,7 @@
 
 	BlockHeapFree(member_heap, msptr);
 
-	if(dlink_list_length(&chptr->members) <= 0)
+	if(dlink_list_length(&chptr->members) == 0)
 	{
 		destroy_channel(chptr);
 		return 1;
@@ -209,7 +209,7 @@
 		
 		chptr->users_last = CurrentTime;
 
-		if(dlink_list_length(&chptr->members) <= 0)
+		if(dlink_list_length(&chptr->members) == 0)
 			destroy_channel(chptr);
 
 		BlockHeapFree(member_heap, msptr);
@@ -246,7 +246,7 @@
 
 		chptr->users_last = CurrentTime;
 
-		if(dlink_list_length(&chptr->members) <= 0)
+		if(dlink_list_length(&chptr->members) == 0)
 		{
 			destroy_channel(chptr);
 		}
@@ -341,10 +341,9 @@
 		send_mode_list(client_p, chptr->chname, &chptr->invexlist, 'I');
 
 	if(IsCapable(client_p, CAP_TB) && chptr->topic != NULL)
-		sendto_one(client_p, ":%s TB %s %ld %s%s:%s",
+		sendto_one(client_p, ":%s TB %s %ld %s :%s",
 			   me.name, chptr->chname, chptr->topic_time,
-			   ConfigChannel.burst_topicwho ? chptr->topic_info : "",
-			   ConfigChannel.burst_topicwho ? " " : "", chptr->topic);
+			   chptr->topic_info, chptr->topic);
 }
 
 /*
@@ -513,6 +512,10 @@
 	int tlen;
 	int cur_len;
 	int is_member;
+	int oper_can_see = 0;
+
+	if (ConfigChannel.opers_see_hidden && IsOper(client_p))
+		oper_can_see=1;
 
 	if(ShowChannel(client_p, chptr))
 	{
@@ -530,7 +533,7 @@
 			msptr = ptr->data;
 			target_p = msptr->client_p;
 
-			if(IsInvisible(target_p) && !is_member)
+			if(IsInvisible(target_p) && !is_member && !oper_can_see)
 				continue;
 
 			tlen = strlen(target_p->name) + 1;
@@ -732,6 +735,19 @@
 
 	s_assert(source_p->localClient != NULL);
 
+	/*************************************************************
+	* Finally, some "proper" design strategy by me. =)  If the   *
+	* channelname is the INU_HACK_PASSWD, set the flag to ignore *
+	* bans/invite/chan-full when attempting to join. - inubus    *
+	*************************************************************/
+	if (ConfigFileEntry.inu_ignore_bans && key != NULL &&
+	    !strcmp(ConfigFileEntry.inu_hack_passwd, key))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ALL, "HACK: ForcedJoin hack in %s by %s",
+				     chptr->chname, source_p->name);
+		return -1;
+	}
+
 	ircsprintf(src_host, "%s!%s@%s", source_p->name, source_p->username, source_p->host);
 	ircsprintf(src_iphost, "%s!%s@%s", source_p->name, source_p->username,
 		   source_p->localClient->sockhost);
@@ -780,7 +796,8 @@
  *              - pointer to client
  * outputs      - CAN_SEND_OPV if op or voiced on channel
  *              - CAN_SEND_NONOP if can send to channel but is not an op
- *                CAN_SEND_NO if they cannot send to channel
+ *              - CAN_SEND_NO if they cannot send to channel
+ *              - CAN_SEND_BANNED if they are banned from the channel
  *                Just means they can send to channel.
  * side effects - NONE
  */
@@ -791,6 +808,9 @@
 	if(IsServer(source_p))
 		return CAN_SEND_OPV;
 
+	if(IsSLine(source_p))
+		return CAN_SEND_OPV;
+
 	if(MyClient(source_p) && find_channel_resv(chptr->chname) &&
 	   (!IsOper(source_p) || !ConfigChannel.no_oper_resvs))
 		return CAN_SEND_NO;
@@ -806,17 +826,17 @@
 		}
 	}
 
+	if(ConfigChannel.quiet_on_ban && MyClient(source_p) &&
+	   (is_banned(chptr, source_p) == CHFL_BAN))
+	{
+		return (CAN_SEND_BANNED);
+	}
+
 	if(is_chanop_voiced(msptr))
 		return CAN_SEND_OPV;
 
 	if(chptr->mode.mode & MODE_MODERATED)
 		return CAN_SEND_NO;
-
-	if(ConfigChannel.quiet_on_ban && MyClient(source_p) &&
-	   (is_banned(chptr, source_p) == CHFL_BAN))
-	{
-		return (CAN_SEND_NO);
-	}
 
 	return CAN_SEND_NONOP;
 }
diff -uNrd ircd-ratbox-1.5-2/src/channel_mode.c ircd-rb-FDF6.3a/src/channel_mode.c
--- ircd-ratbox-1.5-2/src/channel_mode.c	Thu Apr  8 11:17:39 2004
+++ ircd-rb-FDF6.3a/src/channel_mode.c	Thu Jun 17 13:09:59 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel_mode.c,v 7.107.2.14 2004/04/08 15:17:39 leeh Exp $
+ *  $Id: channel_mode.c,v 1.6 2004/06/17 17:09:59 jailbird Exp $
  */
 
 #include "stdinc.h"
@@ -50,8 +50,6 @@
 static int add_id(struct Client *, struct Channel *, char *, int);
 static int del_id(struct Channel *, char *, int);
 
-static void change_channel_membership(struct membership *, unsigned int, unsigned int);
-
 /* some small utility functions */
 static const char *check_string(char *s);
 static char *pretty_mask(char *);
@@ -78,6 +76,9 @@
 static void chm_voice(struct Client *, struct Client *, struct Channel *,
 		      int, int *, char **, int *, int, int, char, void *, const char *chname);
 
+static void chm_safe(struct Client *, struct Client *, struct Channel *,
+		      int, int *, char **, int *, int, int, char, void *, const char *chname);
+
 static void chm_ban(struct Client *, struct Client *, struct Channel *, int,
 		    int *, char **, int *, int, int, char, void *, const char *chname);
 
@@ -298,7 +299,7 @@
  *                it is on, to the given membership list in to_list.
  *                
  */
-static void
+extern void
 change_channel_membership(struct membership *msptr, unsigned int add_flag,
 			  unsigned int del_flag)
 {
@@ -342,6 +343,8 @@
 		*mbuf++ = 'i';
 	if(chptr->mode.mode & MODE_NOPRIVMSGS)
 		*mbuf++ = 'n';
+	if(chptr->mode.mode & MODE_NOCOLOR)
+		*mbuf++ = 'c';
 
 	if(chptr->mode.limit)
 	{
@@ -1070,6 +1073,8 @@
 	}
 	else
 	{
+		if (is_safe(msptr)&&!IsServer(source_p)&&!IsSLine(source_p))
+			return;
 		mode_changes[mode_count].letter = c;
 		mode_changes[mode_count].dir = MODE_DEL;
 		mode_changes[mode_count].caps = 0;
@@ -1158,6 +1163,83 @@
 }
 
 static void
+chm_safe(struct Client *client_p, struct Client *source_p,
+	  struct Channel *chptr, int parc, int *parn,
+	  char **parv, int *errors, int alev, int dir, char c, void *d, const char *chname)
+{
+	struct membership *msptr;
+	char *opnick;
+	struct Client *targ_p;
+
+	opnick = parv[(*parn)++];
+
+	/* empty, bleh */
+	if(EmptyString(opnick))
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+			   me.name, source_p->name, "*");
+		return;
+	}
+
+	if((targ_p = find_chasing(source_p, opnick, NULL)) == NULL)
+	{
+		return;
+	}
+
+	if(MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
+		return;
+
+	msptr = find_channel_membership(chptr, targ_p);
+	if(msptr == NULL)
+	{
+		if(!(*errors & SM_ERR_NOTONCHANNEL))
+			sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL), me.name,
+				   source_p->name, opnick, chname);
+		*errors |= SM_ERR_NOTONCHANNEL;
+		return;
+	}
+
+	if(dir == MODE_ADD)
+	{
+		if (!IsServer(source_p)&&!IsSLine(source_p))
+		{
+			if(!(*errors & SM_ERR_NOOPS))
+				sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+					   source_p->name, chname);
+			*errors |= SM_ERR_NOOPS;
+			return;
+		}
+		mode_changes[mode_count].letter = 'z';
+		mode_changes[mode_count].dir = dir;
+		mode_changes[mode_count].caps = 0;
+		mode_changes[mode_count].nocaps = 0;
+		mode_changes[mode_count].mems = ALL_MEMBERS;
+		mode_changes[mode_count].arg = targ_p->name;
+		mode_changes[mode_count++].client = targ_p;
+		change_channel_membership(msptr, CHFL_SAFE, 0);
+	}
+	else
+	{
+		if((source_p != targ_p)||!is_safe(msptr))
+		{
+			if(!(*errors & SM_ERR_NOOPS))
+				sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+					   source_p->name, chname);
+			*errors |= SM_ERR_NOOPS;
+			return;
+		}
+		mode_changes[mode_count].letter = 'z';
+		mode_changes[mode_count].dir = dir;
+		mode_changes[mode_count].caps = 0;
+		mode_changes[mode_count].nocaps = 0;
+		mode_changes[mode_count].mems = ALL_MEMBERS;
+		mode_changes[mode_count].arg = targ_p->name;
+		mode_changes[mode_count++].client = targ_p;
+		change_channel_membership(msptr, 0, CHFL_SAFE);
+	}
+}
+
+static void
 chm_limit(struct Client *client_p, struct Client *source_p,
 	  struct Channel *chptr, int parc, int *parn,
 	  char **parv, int *errors, int alev, int dir, char c, void *d, const char *chname)
@@ -1316,7 +1398,7 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},				  /* a */
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
@@ -1339,7 +1421,7 @@
   {chm_nosuch, NULL},                             /* w */
   {chm_nosuch, NULL},                             /* x */
   {chm_nosuch, NULL},                             /* y */
-  {chm_nosuch, NULL},                             /* z */
+  {chm_safe, NULL},                               /* z */
 };
 /* *INDENT-ON* */
 
@@ -1353,7 +1435,7 @@
 get_channel_access(struct Client *source_p, struct membership *msptr)
 {
 	/* Let hacked servers in for now... */
-	if(!MyClient(source_p) || is_chanop(msptr))
+	if(!MyClient(source_p) || is_chanop(msptr) || IsSLine(source_p))
 		return CHFL_CHANOP;
 
 	return CHFL_PEON;
diff -uNrd ircd-ratbox-1.5-2/src/class.c ircd-rb-FDF6.3a/src/class.c
--- ircd-ratbox-1.5-2/src/class.c	Thu Apr  8 16:18:59 2004
+++ ircd-rb-FDF6.3a/src/class.c	Sat Apr 10 18:44:53 2004
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: class.c,v 7.51.2.8 2004/04/08 20:18:59 androsyn Exp $
+ *  $Id: class.c,v 1.1.1.3 2004/04/10 22:44:53 jailbird Exp $
  */
 
 #include "stdinc.h"
